import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { createContext, useContext, useMemo, useEffect } from 'react';
import { inject } from 'mobx-react';
import { observer } from 'mobx-react-lite';
import { injectIntl } from 'react-intl';
import SecretTableDataSet from "./SecretTableDataSet";
import { useResourceStore } from "../../../../stores";
import useSecretStore from "../../../stores/useSecretStore";
import getTablePostData from "../../../../../../utils/getTablePostData";
var Store = /*#__PURE__*/createContext();
export function useKeyValueStore() {
  return useContext(Store);
}
export var StoreProvider = injectIntl(inject('AppState')(observer(function (props) {
  var id = props.AppState.currentMenuType.id,
      children = props.children;

  var _useResourceStore = useResourceStore(),
      formatMessage = _useResourceStore.intl.formatMessage,
      _useResourceStore$res = _useResourceStore.resourceStore,
      parentId = _useResourceStore$res.getSelectedMenu.parentId,
      setUpTarget = _useResourceStore$res.setUpTarget,
      getUpTarget = _useResourceStore$res.getUpTarget,
      CIPHER_GROUP = _useResourceStore.itemTypes.CIPHER_GROUP;

  var SecretTableDs = useMemo(function () {
    return new _DataSet(SecretTableDataSet({
      formatMessage: formatMessage
    }));
  }, []);
  var formStore = useSecretStore();
  useEffect(function () {
    SecretTableDs.transport = {
      read: function read(_ref) {
        var data = _ref.data;
        var postData = getTablePostData(data);
        return {
          url: "/devops/v1/projects/".concat(id, "/secret/page_by_options?env_id=").concat(parentId),
          method: 'post',
          data: postData
        };
      },
      destroy: function destroy(_ref2) {
        var _ref2$data = _slicedToArray(_ref2.data, 1),
            data = _ref2$data[0];

        return {
          url: "/devops/v1/projects/".concat(id, "/secret/").concat(parentId, "/").concat(data.id),
          method: 'delete',
          data: data
        };
      }
    };
    SecretTableDs.query();
  }, [id, parentId]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    permissions: {
      edit: ['choerodon.code.project.deploy.app-deployment.resource.ps.edit-cipher'],
      "delete": ['choerodon.code.project.deploy.app-deployment.resource.ps.delete-cipher']
    },
    formStore: formStore,
    SecretTableDs: SecretTableDs
  });

  useEffect(function () {
    var type = getUpTarget.type,
        envId = getUpTarget.id;

    if (parentId === envId) {
      if (type === CIPHER_GROUP) {
        SecretTableDs.query();
        setUpTarget({});
      }
    }
  }, [getUpTarget]);
  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
})));